<script setup lang="ts">
// import ShareNetwork from "vue-social-sharing"
import html2canvas from "html2canvas";
// import querystring from "querystring"
import qs from "qs";

interface Props {
  card: StormCard;
}
const props = defineProps<Props>();
const downloadPict = () => {
  html2canvas(document.getElementById(`word-${props.card.No}`)).then(
    (canvas) => {
      const link = document.createElement("a");
      link.href = canvas.toDataURL();
      link.download = `${props.card.word}.png`;
      link.click();
    }
  );
};
const shareToTwitter = () => {
  const config = useRuntimeConfig();
  const link = document.createElement("a");
  const url = `${config.site}/storm/card`;
  const myquery = qs.stringify({
    word: props.card.word,
    ori: props.card.ori,
    src: props.card.src,
    tgt: props.card.tgt,
    comment: props.card.comment,
    author: props.card.author,
  });
  const query = qs.stringify({
    text: "TRANSTORMERで情報共有しよう！",
    hashtags: "中国語学習,TRANSTORMER",
    url: `${url}?${myquery}`,
  });
  const href = `http://twitter.com/share?${query}`;
  console.log(href);
  link.href = href;
  link.target = "_blank";
  link.click();
};
</script>

<template>
  <div class="card m-5 p-5 word-card" :id="'word-' + card.No">
    <div class="card-content has-text-centered">
      <div class="block">
        <p
          class="is-size-3 has-text-weight-bold"
          :class="{
            'is-lang-ja': card.tgt === 'ja',
            'is-lang-zh': card.tgt === 'zh',
          }"
        >
          {{ card.word }}
          <span class="tag is-dark is-pulled-left">{{
            card.tgt.toUpperCase()
          }}</span>
        </p>
      </div>

      <div class="block" v-if="card.ori !== ''">
        <p
          class="is-size-4 has-text-weight-semibold"
          :class="{
            'is-lang-ja': card.src === 'ja',
            'is-lang-zh': card.src === 'zh',
          }"
        >
          <span class="tag is-dark is-pulled-left">{{
            card.src.toUpperCase()
          }}</span
          >{{ card.ori }}
        </p>
      </div>

      <div class="block" v-if="card.comment !== ''">
        <p class="is-size-5 has-text-weight-medium">
          {{ card.comment }}
        </p>
      </div>
    </div>

    <div class="card-footer">
      <a href="#" class="card-footer-item">{{ card.author }}</a>
      <button
        class="card-footer-item button is-primary m-2"
        @click="downloadPict"
      >
        画像で保存
      </button>
      <button
        class="card-footer-item button is-primary is-outlined m-2"
        @click="shareToTwitter"
      >
        つぶやく
      </button>
    </div>
  </div>
</template>



<style langs="scss">
div.word-card {
  width: 85vw;
}
@media screen and (min-width: 1024px) {
  div.word-card {
    width: 30vw;
  }
}
</style>